Package org.flowable.engine

# Interface ProcessEngine

All Superinterfaces:
  `Engine`

public interface ProcessEngine extends Engine
Provides access to all the services that expose the BPM and workflow operations.

- `RuntimeService`: Allows the creation of `Deployment`s and the starting of and searching on `ProcessInstance`s.
- `TaskService`: Exposes operations to manage human (standalone) `Task`s, such as claiming, completing and assigning tasks
- `IdentityService`: Used for managing users, groups and the relations between them
- `ManagementService`: Exposes engine admin and maintenance operations
- `HistoryService`: Service exposing information about ongoing and past process instances.

Typically, there will be only one central ProcessEngine instance needed in a end-user application. Building a ProcessEngine is done through a `ProcessEngineConfiguration` instance and is a costly operation which should be avoided. For that purpose, it is advised to store it in a static field or JNDI location (or something similar). This is a thread-safe object, so no special precautions need to be taken.

Author:
  Tom Baeyens, Joram Barrez

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `VERSION`
  the version of the flowable library

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DynamicBpmnService`
  `getDynamicBpmnService()`
  `FormService`
  `getFormService()`
  `HistoryService`
  `getHistoryService()`
  `IdentityService`
  `getIdentityService()`
  `ManagementService`
  `getManagementService()`
  `ProcessEngineConfiguration`
  `getProcessEngineConfiguration()`
  `ProcessMigrationService`
  `getProcessMigrationService()`
  `RepositoryService`
  `getRepositoryService()`
  `RuntimeService`
  `getRuntimeService()`
  `TaskService`
  `getTaskService()`
  `void`
  `startExecutors()`
  Starts the executors (async and async history), if they are configured to be auto-activated.

  ### Methods inherited from interface org.flowable.common.engine.api.Engine

  `close, getName`

- ## Field Details

  - ### VERSION

    static final String VERSION
    the version of the flowable library
    See Also:
      - Constant Field Values

- ## Method Details

  - ### startExecutors

    void startExecutors()
    Starts the executors (async and async history), if they are configured to be auto-activated.

  - ### getRepositoryService

    RepositoryService getRepositoryService()

  - ### getRuntimeService

    RuntimeService getRuntimeService()

  - ### getFormService

    FormService getFormService()

  - ### getTaskService

    TaskService getTaskService()

  - ### getHistoryService

    HistoryService getHistoryService()

  - ### getIdentityService

    IdentityService getIdentityService()

  - ### getManagementService

    ManagementService getManagementService()

  - ### getDynamicBpmnService

    DynamicBpmnService getDynamicBpmnService()

  - ### getProcessMigrationService

    ProcessMigrationService getProcessMigrationService()

  - ### getProcessEngineConfiguration

    ProcessEngineConfiguration getProcessEngineConfiguration()